=== debian/changelog ===
gle-graphics (4.3.7-1) unstable; urgency=medium

  * New upstream release.
  * Recommend libgs10 instead of libgs9. Closes: #1115362
  * Build-depend on pkgconf instead of obsolete pkg-config.
  * Update Standards-Version to 4.7.2 (no changes)
  * New patch: correct ifdef with multiple tokens
  * New patch: fix CMake Warning(dev): CMP0167

 -- Christian T. Steigies <cts@debian.org>  Sun, 31 Aug 2025 20:50:52 +0200
