=== debian/tests/control ===
Test-Command: gle -info
Depends: gle-graphics
