=== debian/watch ===
version=4
opts="mode=git" https://github.com/vlabella/GLE.git \
  refs/tags/v([\d\.]+) debian uupdate
