## gle-graphics 4.3.8

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,12 @@
 #
 # -- CMakeLists.txt for GLE - Graphics Layout Engine
 #
-cmake_minimum_required (VERSION 3.18)
+cmake_minimum_required (VERSION 3.30)
 cmake_policy(SET CMP0091 NEW) 	# windows static runtimes selection
 #cmake_policy(SET CMP0167 NEW)	# The FindBoost module is removed. only for cmake 3.30 and later live with the warning for now
 cmake_policy(SET CMP0074 NEW)	# uses <PackageName>_ROOT variables.
+set(CMAKE_CXX_STANDARD 17)
+set(CMAKE_CXX_STANDARD_REQUIRED ON)
 include(CheckIncludeFile)
 include(CheckIncludeFiles)
 include(CheckIncludeFileCXX)
@@ -15,8 +17,8 @@
 	list(INSERT CMAKE_MODULE_PATH 0 ${ECM_MODULE_PATH})
 endif()
 
-set( CMAKE_OSX_DEPLOYMENT_TARGET "10.14" CACHE STRING "Minimum OS X deployment version")	# minimum supported by apple
-project( gle VERSION 4.3.7 )
+set( CMAKE_OSX_DEPLOYMENT_TARGET "10.15" CACHE STRING "Minimum OS X deployment version")	# minimum supported by apple
+project( gle VERSION 4.3.8 )
 add_compile_definitions(GLEVN="${PROJECT_VERSION}")
 set( CMAKE_DEBUG_POSTFIX  "d")
 #
@@ -30,10 +32,14 @@
 
 option(BUILD_GUI "Build the GUI - gle Previewer" ON)
 option(BUILD_MANIP "Build manip program" BUILD_MANIP_DEFAULT)
+option(BUILD_GLEBTOOL "Build glebtool program - deprecated" OFF)
+option(INSTALL_FBUILD "Install the fbuild program - only needed during gle build phase" OFF)
+option(INSTALL_MAKEFMT "Install the makefmt program - only needed during gle build phase" OFF)
 option(MSVC_USE_STATIC_RUNTIME "Build and link against the windows static runtime (/MT) (windows only)" OFF)
 option(GLE_EXAMPLES_LIBRARY_PATH "Path to gle-examples.  Only needed when using cpack to build distributables" "./gle-examples")
 option(GLE_USER_MANUAL_PATH "Path to gle-manual when gle-manual.pdf resides.  Only needed when using cpack to build distributables" "./gle-manual")
 option(EXTRA_GSLIB_SEARCH_LOCATION "Extra path for searching for gslib on linux and macOS" OFF)
+# option(BITMAP_CREATION_POPPLER "Use poppler library for bitmap creation instead of ghostscript" OFF)
 
 if(NOT DEFINED POPPLER_INTERFACE)
 	# poppler interface defaults if not set -> CPP for Windows, GLIB for Linux and Apple/Darwin
@@ -281,13 +287,3 @@
 	set(HAS_DEBUG )
 	string(COMPARE NOTEQUAL "${PIXMAN_DEBUG}" "PIXMAN_DEBUG-NOTFOUND" HAS_DEBUG)
 	if(HAS_DEBUG)
-		list(APPEND PIXMAN_LIBRARIES "optimized")
-		list(APPEND PIXMAN_LIBRARIES ${PIXMAN_RELEASE})
-		list(APPEND PIXMAN_LIBRARIES "debug")
-		list(APPEND PIXMAN_LIBRARIES ${PIXMAN_DEBUG})
-	else()
-		list(APPEND PIXMAN_LIBRARIES ${PIXMAN_RELEASE})
-	endif()
-else()
-	find_library(PIXMAN_LIBRARIES NAMES pixman pixmand pixman-1 PATHS ${PIXMAN_ROOT} PATH_SUFFIXES lib REQUIRED)
-	string(COMPARE NOTEQUAL "${PIXMAN_LIBRARIES}" "PIXMAN_LIBRARIES-NOTFOUND" PIXMAN_FOUND)
