=== debian/changelog ===
gle-graphics (4.3.8-1) experimental; urgency=medium

  * New upstream release.
  * Add upstream patch to eliminate stackunderflow in qgle
  * Add upstream patch to set GLE_TOP when creating inittex.ini

 -- Christian T. Steigies <cts@debian.org>  Sun, 19 Oct 2025 18:25:44 +0200
