=== debian/control ===
--- 
+++ 
@@ -13,12 +13,12 @@
                libjpeg-dev,
                libpng-dev,
                libpoppler-glib-dev,
-               qtbase5-dev,
-               libqt5opengl5-dev,
+               libqt6opengl6-dev,
                libtiff-dev,
                libtool,
                libncurses-dev,
                pkgconf,
+               qt6-5compat-dev,
                extra-cmake-modules
 Standards-Version: 4.7.2
 Homepage: http://glx.sf.net
@@ -40,9 +40,3 @@
  .
  GLE relies on LaTeX for text output and supports mathematical formulae
  in graphs and figures. Output formats include (E)PS, PDF, JPEG, and PNG.
-
-Package: gle-graphics-glebtool
-Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}, gle-graphics (>= ${source:Version}) 
-Description: Graphics Layout Engine glebtool
- glebtool is used to build the PDF gle-graphics-manual
